<?php
namespace AsalaeCore\Test\Mock;

use SoapClient;

class SoapClientMocked extends SoapClient
{
    const TOKEN_SAMPLE = TESTS . 'Data' . DS . 'sample.token';

    /** @noinspection PhpMissingParentConstructorInspection */
    public function __construct($wsdl, array $options = null)
    {
    }

    public function __soapCall(
        $name,
        $args,
        $options = null,
        $inputHeaders = null,
        &$outputHeaders = null
    ): mixed {
        switch ($name) {
            case 'createRequest':
            case 'createResponse':
                return true;
            case 'extractToken':
                return base64_encode(file_get_contents(self::TOKEN_SAMPLE));
            case 'getOpensslVersion':
                return 'not empty';
        }
    }
}
